test-lib: extract Bash version check for '-x' tracing
[git.git] / t / test-lib.sh
blob1f02e2e25b9e09e61cbed88279c883a64a206da3
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
60 ################################################################
61 # It appears that people try to run tests without building...
62 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
63 if test $? != 1
64 then
65 if test -n "$GIT_TEST_INSTALLED"
66 then
67 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
68 else
69 echo >&2 'error: you do not seem to have built git yet.'
71 exit 1
74 # if --tee was passed, write the output not only to the terminal, but
75 # additionally to the file test-results/$BASENAME.out, too.
76 case "$GIT_TEST_TEE_STARTED, $* " in
77 done,*)
78 # do not redirect again
80 *' --tee '*|*' --va'*|*' -V '*|*' --verbose-log '*)
81 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
82 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
84 # Make this filename available to the sub-process in case it is using
85 # --verbose-log.
86 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
87 export GIT_TEST_TEE_OUTPUT_FILE
89 # Truncate before calling "tee -a" to get rid of the results
90 # from any previous runs.
91 >"$GIT_TEST_TEE_OUTPUT_FILE"
93 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
94 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
95 test "$(cat "$BASE.exit")" = 0
96 exit
98 esac
100 # For repeatability, reset the environment to known value.
101 # TERM is sanitized below, after saving color control sequences.
102 LANG=C
103 LC_ALL=C
104 PAGER=cat
105 TZ=UTC
106 export LANG LC_ALL PAGER TZ
107 EDITOR=:
109 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
110 # during initialization of test-lib and the test repo. Back it up,
111 # unset and then restore after initialization is finished.
112 if test -n "$GIT_TEST_GETTEXT_POISON"
113 then
114 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
115 unset GIT_TEST_GETTEXT_POISON
118 # A call to "unset" with no arguments causes at least Solaris 10
119 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
120 # deriving from the command substitution clustered with the other
121 # ones.
122 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
123 my @env = keys %ENV;
124 my $ok = join("|", qw(
125 TRACE
126 DEBUG
127 TEST
128 .*_TEST
129 PROVE
130 VALGRIND
131 UNZIP
132 PERF_
133 CURL_VERBOSE
134 TRACE_CURL
136 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
137 print join("\n", @vars);
139 unset XDG_CACHE_HOME
140 unset XDG_CONFIG_HOME
141 unset GITPERLLIB
142 GIT_AUTHOR_EMAIL=author@example.com
143 GIT_AUTHOR_NAME='A U Thor'
144 GIT_COMMITTER_EMAIL=committer@example.com
145 GIT_COMMITTER_NAME='C O Mitter'
146 GIT_MERGE_VERBOSITY=5
147 GIT_MERGE_AUTOEDIT=no
148 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
149 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
150 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
151 export EDITOR
153 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
154 GIT_TRACE_BARE=1
155 export GIT_TRACE_BARE
157 check_var_migration () {
158 # the warnings and hints given from this helper depends
159 # on end-user settings, which will disrupt the self-test
160 # done on the test framework itself.
161 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
162 t) return ;;
163 esac
165 old_name=$1 new_name=$2
166 eval "old_isset=\${${old_name}:+isset}"
167 eval "new_isset=\${${new_name}:+isset}"
169 case "$old_isset,$new_isset" in
170 isset,)
171 echo >&2 "warning: $old_name is now $new_name"
172 echo >&2 "hint: set $new_name too during the transition period"
173 eval "$new_name=\$$old_name"
175 isset,isset)
176 # do this later
177 # echo >&2 "warning: $old_name is now $new_name"
178 # echo >&2 "hint: remove $old_name"
180 esac
183 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
184 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
185 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
187 # Use specific version of the index file format
188 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
189 then
190 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
191 export GIT_INDEX_VERSION
194 # Add libc MALLOC and MALLOC_PERTURB test
195 # only if we are not executing the test with valgrind
196 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
197 test -n "$TEST_NO_MALLOC_CHECK"
198 then
199 setup_malloc_check () {
200 : nothing
202 teardown_malloc_check () {
203 : nothing
205 else
206 setup_malloc_check () {
207 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
208 export MALLOC_CHECK_ MALLOC_PERTURB_
210 teardown_malloc_check () {
211 unset MALLOC_CHECK_ MALLOC_PERTURB_
215 # Protect ourselves from common misconfiguration to export
216 # CDPATH into the environment
217 unset CDPATH
219 unset GREP_OPTIONS
220 unset UNZIP
222 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
223 1|2|true)
224 GIT_TRACE=4
226 esac
228 # Convenience
230 # A regexp to match 5, 35 and 40 hexdigits
231 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
232 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
233 _x40="$_x35$_x05"
235 # Zero SHA-1
236 _z40=0000000000000000000000000000000000000000
238 OID_REGEX="$_x40"
239 ZERO_OID=$_z40
240 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
241 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
243 # Line feed
244 LF='
247 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
248 # when case-folding filenames
249 u200c=$(printf '\342\200\214')
251 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
253 # Each test should start with something like this, after copyright notices:
255 # test_description='Description of this test...
256 # This test checks if command xyzzy does the right thing...
258 # . ./test-lib.sh
259 test "x$TERM" != "xdumb" && (
260 test -t 1 &&
261 tput bold >/dev/null 2>&1 &&
262 tput setaf 1 >/dev/null 2>&1 &&
263 tput sgr0 >/dev/null 2>&1
264 ) &&
265 color=t
267 while test "$#" -ne 0
269 case "$1" in
270 -d|--d|--de|--deb|--debu|--debug)
271 debug=t; shift ;;
272 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
273 immediate=t; shift ;;
274 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
275 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
277 shift; test "$#" -ne 0 || {
278 echo 'error: -r requires an argument' >&2;
279 exit 1;
281 run_list=$1; shift ;;
282 --run=*)
283 run_list=${1#--*=}; shift ;;
284 -h|--h|--he|--hel|--help)
285 help=t; shift ;;
286 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
287 verbose=t; shift ;;
288 --verbose-only=*)
289 verbose_only=${1#--*=}
290 shift ;;
291 -q|--q|--qu|--qui|--quie|--quiet)
292 # Ignore --quiet under a TAP::Harness. Saying how many tests
293 # passed without the ok/not ok details is always an error.
294 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
295 --with-dashes)
296 with_dashes=t; shift ;;
297 --no-color)
298 color=; shift ;;
299 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
300 valgrind=memcheck
301 shift ;;
302 --valgrind=*)
303 valgrind=${1#--*=}
304 shift ;;
305 --valgrind-only=*)
306 valgrind_only=${1#--*=}
307 shift ;;
308 --tee)
309 shift ;; # was handled already
310 --root=*)
311 root=${1#--*=}
312 shift ;;
313 --chain-lint)
314 GIT_TEST_CHAIN_LINT=1
315 shift ;;
316 --no-chain-lint)
317 GIT_TEST_CHAIN_LINT=0
318 shift ;;
320 trace=t
321 shift ;;
322 -V|--verbose-log)
323 verbose_log=t
324 shift ;;
326 echo "error: unknown test option '$1'" >&2; exit 1 ;;
327 esac
328 done
330 if test -n "$valgrind_only"
331 then
332 test -z "$valgrind" && valgrind=memcheck
333 test -z "$verbose" && verbose_only="$valgrind_only"
334 elif test -n "$valgrind"
335 then
336 test -z "$verbose_log" && verbose=t
339 if test -n "$trace" && test -n "$test_untraceable"
340 then
341 # '-x' tracing requested, but this test script can't be reliably
342 # traced, unless it is run with a Bash version supporting
343 # BASH_XTRACEFD (introduced in Bash v4.1).
344 if test -n "$BASH_VERSION" && eval '
345 test ${BASH_VERSINFO[0]} -gt 4 || {
346 test ${BASH_VERSINFO[0]} -eq 4 &&
347 test ${BASH_VERSINFO[1]} -ge 1
350 then
351 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
352 else
353 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
354 trace=
357 if test -n "$trace" && test -z "$verbose_log"
358 then
359 verbose=t
362 if test -n "$color"
363 then
364 # Save the color control sequences now rather than run tput
365 # each time say_color() is called. This is done for two
366 # reasons:
367 # * TERM will be changed to dumb
368 # * HOME will be changed to a temporary directory and tput
369 # might need to read ~/.terminfo from the original HOME
370 # directory to get the control sequences
371 # Note: This approach assumes the control sequences don't end
372 # in a newline for any terminal of interest (command
373 # substitutions strip trailing newlines). Given that most
374 # (all?) terminals in common use are related to ECMA-48, this
375 # shouldn't be a problem.
376 say_color_error=$(tput bold; tput setaf 1) # bold red
377 say_color_skip=$(tput setaf 4) # blue
378 say_color_warn=$(tput setaf 3) # brown/yellow
379 say_color_pass=$(tput setaf 2) # green
380 say_color_info=$(tput setaf 6) # cyan
381 say_color_reset=$(tput sgr0)
382 say_color_="" # no formatting for normal text
383 say_color () {
384 test -z "$1" && test -n "$quiet" && return
385 eval "say_color_color=\$say_color_$1"
386 shift
387 printf "%s\\n" "$say_color_color$*$say_color_reset"
389 else
390 say_color() {
391 test -z "$1" && test -n "$quiet" && return
392 shift
393 printf "%s\n" "$*"
397 TERM=dumb
398 export TERM
400 error () {
401 say_color error "error: $*"
402 GIT_EXIT_OK=t
403 exit 1
406 BUG () {
407 error >&7 "bug in the test script: $*"
410 say () {
411 say_color info "$*"
414 if test -n "$HARNESS_ACTIVE"
415 then
416 if test "$verbose" = t || test -n "$verbose_only"
417 then
418 printf 'Bail out! %s\n' \
419 'verbose mode forbidden under TAP harness; try --verbose-log'
420 exit 1
424 test "${test_description}" != "" ||
425 error "Test script did not set test_description."
427 if test "$help" = "t"
428 then
429 printf '%s\n' "$test_description"
430 exit 0
433 exec 5>&1
434 exec 6<&0
435 exec 7>&2
436 if test "$verbose_log" = "t"
437 then
438 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
439 elif test "$verbose" = "t"
440 then
441 exec 4>&2 3>&1
442 else
443 exec 4>/dev/null 3>/dev/null
446 # Send any "-x" output directly to stderr to avoid polluting tests
447 # which capture stderr. We can do this unconditionally since it
448 # has no effect if tracing isn't turned on.
450 # Note that this sets up the trace fd as soon as we assign the variable, so it
451 # must come after the creation of descriptor 4 above. Likewise, we must never
452 # unset this, as it has the side effect of closing descriptor 4, which we
453 # use to show verbose tests to the user.
455 # Note also that we don't need or want to export it. The tracing is local to
456 # this shell, and we would not want to influence any shells we exec.
457 BASH_XTRACEFD=4
459 test_failure=0
460 test_count=0
461 test_fixed=0
462 test_broken=0
463 test_success=0
465 test_external_has_tap=0
467 die () {
468 code=$?
469 if test -n "$GIT_EXIT_OK"
470 then
471 exit $code
472 else
473 echo >&5 "FATAL: Unexpected exit with code $code"
474 exit 1
478 GIT_EXIT_OK=
479 trap 'die' EXIT
480 trap 'exit $?' INT TERM HUP
482 # The user-facing functions are loaded from a separate file so that
483 # test_perf subshells can have them too
484 . "$TEST_DIRECTORY/test-lib-functions.sh"
486 # You are not expected to call test_ok_ and test_failure_ directly, use
487 # the test_expect_* functions instead.
489 test_ok_ () {
490 test_success=$(($test_success + 1))
491 say_color "" "ok $test_count - $@"
494 test_failure_ () {
495 test_failure=$(($test_failure + 1))
496 say_color error "not ok $test_count - $1"
497 shift
498 printf '%s\n' "$*" | sed -e 's/^/# /'
499 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
502 test_known_broken_ok_ () {
503 test_fixed=$(($test_fixed+1))
504 say_color error "ok $test_count - $@ # TODO known breakage vanished"
507 test_known_broken_failure_ () {
508 test_broken=$(($test_broken+1))
509 say_color warn "not ok $test_count - $@ # TODO known breakage"
512 test_debug () {
513 test "$debug" = "" || eval "$1"
516 match_pattern_list () {
517 arg="$1"
518 shift
519 test -z "$*" && return 1
520 for pattern_
522 case "$arg" in
523 $pattern_)
524 return 0
525 esac
526 done
527 return 1
530 match_test_selector_list () {
531 title="$1"
532 shift
533 arg="$1"
534 shift
535 test -z "$1" && return 0
537 # Both commas and whitespace are accepted as separators.
538 OLDIFS=$IFS
539 IFS=' ,'
540 set -- $1
541 IFS=$OLDIFS
543 # If the first selector is negative we include by default.
544 include=
545 case "$1" in
546 !*) include=t ;;
547 esac
549 for selector
551 orig_selector=$selector
553 positive=t
554 case "$selector" in
556 positive=
557 selector=${selector##?}
559 esac
561 test -z "$selector" && continue
563 case "$selector" in
564 *-*)
565 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
566 then
567 echo "error: $title: invalid non-numeric in range" \
568 "start: '$orig_selector'" >&2
569 exit 1
571 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
572 then
573 echo "error: $title: invalid non-numeric in range" \
574 "end: '$orig_selector'" >&2
575 exit 1
579 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
580 then
581 echo "error: $title: invalid non-numeric in test" \
582 "selector: '$orig_selector'" >&2
583 exit 1
585 esac
587 # Short cut for "obvious" cases
588 test -z "$include" && test -z "$positive" && continue
589 test -n "$include" && test -n "$positive" && continue
591 case "$selector" in
593 if test $arg -le ${selector#-}
594 then
595 include=$positive
599 if test $arg -ge ${selector%-}
600 then
601 include=$positive
604 *-*)
605 if test ${selector%%-*} -le $arg \
606 && test $arg -le ${selector#*-}
607 then
608 include=$positive
612 if test $arg -eq $selector
613 then
614 include=$positive
617 esac
618 done
620 test -n "$include"
623 maybe_teardown_verbose () {
624 test -z "$verbose_only" && return
625 exec 4>/dev/null 3>/dev/null
626 verbose=
629 last_verbose=t
630 maybe_setup_verbose () {
631 test -z "$verbose_only" && return
632 if match_pattern_list $test_count $verbose_only
633 then
634 exec 4>&2 3>&1
635 # Emit a delimiting blank line when going from
636 # non-verbose to verbose. Within verbose mode the
637 # delimiter is printed by test_expect_*. The choice
638 # of the initial $last_verbose is such that before
639 # test 1, we do not print it.
640 test -z "$last_verbose" && echo >&3 ""
641 verbose=t
642 else
643 exec 4>/dev/null 3>/dev/null
644 verbose=
646 last_verbose=$verbose
649 maybe_teardown_valgrind () {
650 test -z "$GIT_VALGRIND" && return
651 GIT_VALGRIND_ENABLED=
654 maybe_setup_valgrind () {
655 test -z "$GIT_VALGRIND" && return
656 if test -z "$valgrind_only"
657 then
658 GIT_VALGRIND_ENABLED=t
659 return
661 GIT_VALGRIND_ENABLED=
662 if match_pattern_list $test_count $valgrind_only
663 then
664 GIT_VALGRIND_ENABLED=t
668 want_trace () {
669 test "$trace" = t && {
670 test "$verbose" = t || test "$verbose_log" = t
674 # This is a separate function because some tests use
675 # "return" to end a test_expect_success block early
676 # (and we want to make sure we run any cleanup like
677 # "set +x").
678 test_eval_inner_ () {
679 # Do not add anything extra (including LF) after '$*'
680 eval "
681 want_trace && set -x
685 test_eval_ () {
686 # If "-x" tracing is in effect, then we want to avoid polluting stderr
687 # with non-test commands. But once in "set -x" mode, we cannot prevent
688 # the shell from printing the "set +x" to turn it off (nor the saving
689 # of $? before that). But we can make sure that the output goes to
690 # /dev/null.
692 # There are a few subtleties here:
694 # - we have to redirect descriptor 4 in addition to 2, to cover
695 # BASH_XTRACEFD
697 # - the actual eval has to come before the redirection block (since
698 # it needs to see descriptor 4 to set up its stderr)
700 # - likewise, any error message we print must be outside the block to
701 # access descriptor 4
703 # - checking $? has to come immediately after the eval, but it must
704 # be _inside_ the block to avoid polluting the "set -x" output
707 test_eval_inner_ "$@" </dev/null >&3 2>&4
709 test_eval_ret_=$?
710 if want_trace
711 then
712 set +x
714 } 2>/dev/null 4>&2
716 if test "$test_eval_ret_" != 0 && want_trace
717 then
718 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
720 return $test_eval_ret_
723 test_run_ () {
724 test_cleanup=:
725 expecting_failure=$2
727 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
728 # turn off tracing for this test-eval, as it simply creates
729 # confusing noise in the "-x" output
730 trace_tmp=$trace
731 trace=
732 # 117 is magic because it is unlikely to match the exit
733 # code of other programs
734 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
735 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
736 then
737 BUG "broken &&-chain or run-away HERE-DOC: $1"
739 trace=$trace_tmp
742 setup_malloc_check
743 test_eval_ "$1"
744 eval_ret=$?
745 teardown_malloc_check
747 if test -z "$immediate" || test $eval_ret = 0 ||
748 test -n "$expecting_failure" && test "$test_cleanup" != ":"
749 then
750 setup_malloc_check
751 test_eval_ "$test_cleanup"
752 teardown_malloc_check
754 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
755 then
756 echo ""
758 return "$eval_ret"
761 test_start_ () {
762 test_count=$(($test_count+1))
763 maybe_setup_verbose
764 maybe_setup_valgrind
767 test_finish_ () {
768 echo >&3 ""
769 maybe_teardown_valgrind
770 maybe_teardown_verbose
773 test_skip () {
774 to_skip=
775 skipped_reason=
776 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
777 then
778 to_skip=t
779 skipped_reason="GIT_SKIP_TESTS"
781 if test -z "$to_skip" && test -n "$test_prereq" &&
782 ! test_have_prereq "$test_prereq"
783 then
784 to_skip=t
786 of_prereq=
787 if test "$missing_prereq" != "$test_prereq"
788 then
789 of_prereq=" of $test_prereq"
791 skipped_reason="missing $missing_prereq${of_prereq}"
793 if test -z "$to_skip" && test -n "$run_list" &&
794 ! match_test_selector_list '--run' $test_count "$run_list"
795 then
796 to_skip=t
797 skipped_reason="--run"
800 case "$to_skip" in
802 say_color skip >&3 "skipping test: $@"
803 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
804 : true
807 false
809 esac
812 # stub; perf-lib overrides it
813 test_at_end_hook_ () {
817 test_done () {
818 GIT_EXIT_OK=t
820 if test -z "$HARNESS_ACTIVE"
821 then
822 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
823 mkdir -p "$test_results_dir"
824 base=${0##*/}
825 test_results_path="$test_results_dir/${base%.sh}.counts"
827 cat >"$test_results_path" <<-EOF
828 total $test_count
829 success $test_success
830 fixed $test_fixed
831 broken $test_broken
832 failed $test_failure
837 if test "$test_fixed" != 0
838 then
839 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
841 if test "$test_broken" != 0
842 then
843 say_color warn "# still have $test_broken known breakage(s)"
845 if test "$test_broken" != 0 || test "$test_fixed" != 0
846 then
847 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
848 msg="remaining $test_remaining test(s)"
849 else
850 test_remaining=$test_count
851 msg="$test_count test(s)"
853 case "$test_failure" in
855 if test $test_external_has_tap -eq 0
856 then
857 if test $test_remaining -gt 0
858 then
859 say_color pass "# passed all $msg"
862 # Maybe print SKIP message
863 test -z "$skip_all" || skip_all="# SKIP $skip_all"
864 case "$test_count" in
866 say "1..$test_count${skip_all:+ $skip_all}"
869 test -z "$skip_all" ||
870 say_color warn "$skip_all"
871 say "1..$test_count"
873 esac
876 if test -z "$debug"
877 then
878 test -d "$TRASH_DIRECTORY" ||
879 error "Tests passed but trash directory already removed before test cleanup; aborting"
881 cd "$TRASH_DIRECTORY/.." &&
882 rm -fr "$TRASH_DIRECTORY" ||
883 error "Tests passed but test cleanup failed; aborting"
885 test_at_end_hook_
887 exit 0 ;;
890 if test $test_external_has_tap -eq 0
891 then
892 say_color error "# failed $test_failure among $msg"
893 say "1..$test_count"
896 exit 1 ;;
898 esac
901 if test -n "$valgrind"
902 then
903 make_symlink () {
904 test -h "$2" &&
905 test "$1" = "$(readlink "$2")" || {
906 # be super paranoid
907 if mkdir "$2".lock
908 then
909 rm -f "$2" &&
910 ln -s "$1" "$2" &&
911 rm -r "$2".lock
912 else
913 while test -d "$2".lock
915 say "Waiting for lock on $2."
916 sleep 1
917 done
922 make_valgrind_symlink () {
923 # handle only executables, unless they are shell libraries that
924 # need to be in the exec-path.
925 test -x "$1" ||
926 test "# " = "$(test_copy_bytes 2 <"$1")" ||
927 return;
929 base=$(basename "$1")
930 case "$base" in
931 test-*)
932 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
935 symlink_target="$GIT_BUILD_DIR/$base"
937 esac
938 # do not override scripts
939 if test -x "$symlink_target" &&
940 test ! -d "$symlink_target" &&
941 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
942 then
943 symlink_target=../valgrind.sh
945 case "$base" in
946 *.sh|*.perl)
947 symlink_target=../unprocessed-script
948 esac
949 # create the link, or replace it if it is out of date
950 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
953 # override all git executables in TEST_DIRECTORY/..
954 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
955 mkdir -p "$GIT_VALGRIND"/bin
956 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
958 make_valgrind_symlink $file
959 done
960 # special-case the mergetools loadables
961 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
962 OLDIFS=$IFS
963 IFS=:
964 for path in $PATH
966 ls "$path"/git-* 2> /dev/null |
967 while read file
969 make_valgrind_symlink "$file"
970 done
971 done
972 IFS=$OLDIFS
973 PATH=$GIT_VALGRIND/bin:$PATH
974 GIT_EXEC_PATH=$GIT_VALGRIND/bin
975 export GIT_VALGRIND
976 GIT_VALGRIND_MODE="$valgrind"
977 export GIT_VALGRIND_MODE
978 GIT_VALGRIND_ENABLED=t
979 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
980 export GIT_VALGRIND_ENABLED
981 elif test -n "$GIT_TEST_INSTALLED"
982 then
983 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
984 error "Cannot run git from $GIT_TEST_INSTALLED."
985 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
986 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
987 else # normal case, use ../bin-wrappers only unless $with_dashes:
988 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
989 if ! test -x "$git_bin_dir/git"
990 then
991 if test -z "$with_dashes"
992 then
993 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
995 with_dashes=t
997 PATH="$git_bin_dir:$PATH"
998 GIT_EXEC_PATH=$GIT_BUILD_DIR
999 if test -n "$with_dashes"
1000 then
1001 PATH="$GIT_BUILD_DIR:$PATH"
1004 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1005 GIT_CONFIG_NOSYSTEM=1
1006 GIT_ATTR_NOSYSTEM=1
1007 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1009 if test -z "$GIT_TEST_CMP"
1010 then
1011 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1012 then
1013 GIT_TEST_CMP="$DIFF -c"
1014 else
1015 GIT_TEST_CMP="$DIFF -u"
1019 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1020 export GITPERLLIB
1021 test -d "$GIT_BUILD_DIR"/templates/blt || {
1022 error "You haven't built things yet, have you?"
1025 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
1026 then
1027 echo >&2 'You need to build test-tool:'
1028 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1029 exit 1
1032 # Test repository
1033 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
1034 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
1035 case "$TRASH_DIRECTORY" in
1036 /*) ;; # absolute path is good
1037 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
1038 esac
1039 rm -fr "$TRASH_DIRECTORY" || {
1040 GIT_EXIT_OK=t
1041 echo >&5 "FATAL: Cannot prepare test area"
1042 exit 1
1045 HOME="$TRASH_DIRECTORY"
1046 GNUPGHOME="$HOME/gnupg-home-not-used"
1047 export HOME GNUPGHOME
1049 if test -z "$TEST_NO_CREATE_REPO"
1050 then
1051 test_create_repo "$TRASH_DIRECTORY"
1052 else
1053 mkdir -p "$TRASH_DIRECTORY"
1055 # Use -P to resolve symlinks in our working directory so that the cwd
1056 # in subprocesses like git equals our $PWD (for pathname comparisons).
1057 cd -P "$TRASH_DIRECTORY" || exit 1
1059 this_test=${0##*/}
1060 this_test=${this_test%%-*}
1061 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1062 then
1063 say_color info >&3 "skipping test $this_test altogether"
1064 skip_all="skip all tests in $this_test"
1065 test_done
1068 # Provide an implementation of the 'yes' utility
1069 yes () {
1070 if test $# = 0
1071 then
1073 else
1074 y="$*"
1078 while test $i -lt 99
1080 echo "$y"
1081 i=$(($i+1))
1082 done
1085 # Fix some commands on Windows
1086 uname_s=$(uname -s)
1087 case $uname_s in
1088 *MINGW*)
1089 # Windows has its own (incompatible) sort and find
1090 sort () {
1091 /usr/bin/sort "$@"
1093 find () {
1094 /usr/bin/find "$@"
1096 # git sees Windows-style pwd
1097 pwd () {
1098 builtin pwd -W
1100 # no POSIX permissions
1101 # backslashes in pathspec are converted to '/'
1102 # exec does not inherit the PID
1103 test_set_prereq MINGW
1104 test_set_prereq NATIVE_CRLF
1105 test_set_prereq SED_STRIPS_CR
1106 test_set_prereq GREP_STRIPS_CR
1107 GIT_TEST_CMP=mingw_test_cmp
1109 *CYGWIN*)
1110 test_set_prereq POSIXPERM
1111 test_set_prereq EXECKEEPSPID
1112 test_set_prereq CYGWIN
1113 test_set_prereq SED_STRIPS_CR
1114 test_set_prereq GREP_STRIPS_CR
1117 test_set_prereq POSIXPERM
1118 test_set_prereq BSLASHPSPEC
1119 test_set_prereq EXECKEEPSPID
1121 esac
1123 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1124 test -z "$NO_PERL" && test_set_prereq PERL
1125 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1126 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1127 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1128 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1129 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1130 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1132 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1133 then
1134 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1135 unset GIT_TEST_GETTEXT_POISON_ORIG
1138 # Can we rely on git's output in the C locale?
1139 if test -z "$GIT_TEST_GETTEXT_POISON"
1140 then
1141 test_set_prereq C_LOCALE_OUTPUT
1144 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1145 then
1146 GIT_TEST_CHECK_CACHE_TREE=true
1147 export GIT_TEST_CHECK_CACHE_TREE
1150 test_lazy_prereq PIPE '
1151 # test whether the filesystem supports FIFOs
1152 test_have_prereq !MINGW,!CYGWIN &&
1153 rm -f testfifo && mkfifo testfifo
1156 test_lazy_prereq SYMLINKS '
1157 # test whether the filesystem supports symbolic links
1158 ln -s x y && test -h y
1161 test_lazy_prereq FILEMODE '
1162 test "$(git config --bool core.filemode)" = true
1165 test_lazy_prereq CASE_INSENSITIVE_FS '
1166 echo good >CamelCase &&
1167 echo bad >camelcase &&
1168 test "$(cat CamelCase)" != good
1171 test_lazy_prereq FUNNYNAMES '
1172 test_have_prereq !MINGW &&
1173 touch -- \
1174 "FUNNYNAMES tab embedded" \
1175 "FUNNYNAMES \"quote embedded\"" \
1176 "FUNNYNAMES newline
1177 embedded" 2>/dev/null &&
1178 rm -- \
1179 "FUNNYNAMES tab embedded" \
1180 "FUNNYNAMES \"quote embedded\"" \
1181 "FUNNYNAMES newline
1182 embedded" 2>/dev/null
1185 test_lazy_prereq UTF8_NFD_TO_NFC '
1186 # check whether FS converts nfd unicode to nfc
1187 auml=$(printf "\303\244")
1188 aumlcdiar=$(printf "\141\314\210")
1189 >"$auml" &&
1190 test -f "$aumlcdiar"
1193 test_lazy_prereq AUTOIDENT '
1194 sane_unset GIT_AUTHOR_NAME &&
1195 sane_unset GIT_AUTHOR_EMAIL &&
1196 git var GIT_AUTHOR_IDENT
1199 test_lazy_prereq EXPENSIVE '
1200 test -n "$GIT_TEST_LONG"
1203 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1204 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1207 test_lazy_prereq USR_BIN_TIME '
1208 test -x /usr/bin/time
1211 test_lazy_prereq NOT_ROOT '
1212 uid=$(id -u) &&
1213 test "$uid" != 0
1216 test_lazy_prereq JGIT '
1217 type jgit
1220 # SANITY is about "can you correctly predict what the filesystem would
1221 # do by only looking at the permission bits of the files and
1222 # directories?" A typical example of !SANITY is running the test
1223 # suite as root, where a test may expect "chmod -r file && cat file"
1224 # to fail because file is supposed to be unreadable after a successful
1225 # chmod. In an environment (i.e. combination of what filesystem is
1226 # being used and who is running the tests) that lacks SANITY, you may
1227 # be able to delete or create a file when the containing directory
1228 # doesn't have write permissions, or access a file even if the
1229 # containing directory doesn't have read or execute permissions.
1231 test_lazy_prereq SANITY '
1232 mkdir SANETESTD.1 SANETESTD.2 &&
1234 chmod +w SANETESTD.1 SANETESTD.2 &&
1235 >SANETESTD.1/x 2>SANETESTD.2/x &&
1236 chmod -w SANETESTD.1 &&
1237 chmod -r SANETESTD.1/x &&
1238 chmod -rx SANETESTD.2 ||
1239 BUG "cannot prepare SANETESTD"
1241 ! test -r SANETESTD.1/x &&
1242 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1243 status=$?
1245 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1246 rm -rf SANETESTD.1 SANETESTD.2 ||
1247 BUG "cannot clean SANETESTD"
1248 return $status
1251 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1252 GIT_UNZIP=${GIT_UNZIP:-unzip}
1253 test_lazy_prereq UNZIP '
1254 "$GIT_UNZIP" -v
1255 test $? -ne 127
1258 run_with_limited_cmdline () {
1259 (ulimit -s 128 && "$@")
1262 test_lazy_prereq CMDLINE_LIMIT '
1263 test_have_prereq !MINGW,!CYGWIN &&
1264 run_with_limited_cmdline true
1267 run_with_limited_stack () {
1268 (ulimit -s 128 && "$@")
1271 test_lazy_prereq ULIMIT_STACK_SIZE '
1272 test_have_prereq !MINGW,!CYGWIN &&
1273 run_with_limited_stack true
1276 build_option () {
1277 git version --build-options |
1278 sed -ne "s/^$1: //p"
1281 test_lazy_prereq LONG_IS_64BIT '
1282 test 8 -le "$(build_option sizeof-long)"
1285 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1286 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1288 test_lazy_prereq CURL '
1289 curl --version
1292 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1293 # which will not work with other hash algorithms and tests that work but don't
1294 # test anything meaningful (e.g. special values which cause short collisions).
1295 test_lazy_prereq SHA1 '
1296 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1299 test_lazy_prereq REBASE_P '
1300 test -z "$GIT_TEST_SKIP_REBASE_P"